const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const reports = sequelize.define(
    'reports',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"queued",


"running",


"ready",


"failed"

        ],

      },

generated_at: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  reports.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






















//end loop



    db.reports.belongsTo(db.trials, {
      as: 'trial',
      foreignKey: {
        name: 'trialId',
      },
      constraints: false,
    });

    db.reports.belongsTo(db.report_templates, {
      as: 'template',
      foreignKey: {
        name: 'templateId',
      },
      constraints: false,
    });

    db.reports.belongsTo(db.users, {
      as: 'generated_by',
      foreignKey: {
        name: 'generated_byId',
      },
      constraints: false,
    });

    db.reports.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.reports.hasMany(db.file, {
      as: 'report_files',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.reports.getTableName(),
        belongsToColumn: 'report_files',
      },
    });


    db.reports.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.reports.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return reports;
};


